using System;

using Gtk;
using Glade;

using P2Pc.net;

namespace P2Pc.gui {

	public class ClAcceptDialog
	{
		[Glade.Widget] Gtk.Dialog accept_dialog;
		[Glade.Widget] Entry acccomboentry;
		[Glade.Widget] Combo acccombo;
		[Glade.Widget] Label cchanlabel;
		string mstrCChan;
		IPL moPL;

		public ClAcceptDialog(Gtk.Window oParentWindow,
							   IPL oPL,
							   string strCChan)
		{
			moPL = oPL;
			mstrCChan = strCChan;
			Glade.XML gxmlAcceptDia = new Glade.XML(null, "p2pc.glade", "accept_dialog", null);
			if(gxmlAcceptDia!=null){
				gxmlAcceptDia.Autoconnect(this);
				accept_dialog.TransientFor = oParentWindow;
				if(strCChan!=null){
					cchanlabel.Text = strCChan;
					string[] aNickList = 
						new string[CConMan.PKnownUsers.Count];
					int i=0;
					foreach(IUser oUserIter in CConMan.PKnownUsers.Values){
						aNickList[i++] = oUserIter.PNick;
					}
					Array.Sort(aNickList);
					acccombo.PopdownStrings = aNickList;
				}
				else{
					accept_cancel(null, null);
				}
			}
		}

		protected void accept_cancel(object sender, EventArgs e)
		{
			accept_dialog.Hide();
		}

		protected void accept_ok(object sender, EventArgs e){
			string strUser2Acc = acccomboentry.Text;
			if(CConMan.PKnownUsers.Contains(strUser2Acc)){
				moPL.accept_user(strUser2Acc, mstrCChan);
			}
			accept_dialog.Hide();
		}
	}
}
