using System;

using Gtk;
using Glade;

using P2Pc.net;

namespace P2Pc.gui {

	public class ClAddNodeDialog
	{
		[Glade.Widget] Gtk.Dialog addnode_dialog;
		[Glade.Widget] Entry host_entry;
		[Glade.Widget] Entry port_entry;
		IPL moPL;
		DPeerListUpdateMethod mUpdatePeersMethod;

		public ClAddNodeDialog(Gtk.Window oParentWindow,
							   IPL oPL,
							   DPeerListUpdateMethod update_peers)
		{
			mUpdatePeersMethod = update_peers;
			moPL = oPL;
			Glade.XML gxmlAddNodeDia = new Glade.XML(null, "p2pc.glade", "addnode_dialog", null);
			if(gxmlAddNodeDia!=null){
				gxmlAddNodeDia.Autoconnect(this);
				addnode_dialog.TransientFor = oParentWindow;
			}
		}

		protected void cancel_creation(object sender, EventArgs e)
		{
			addnode_dialog.Hide();
		}

		protected void add_node(object sender, EventArgs e)
		{
			try{
				if(!moPL.add_node(host_entry.Text, 
								  Convert.ToInt32(port_entry.Text))){
					ClMsgDias.Err("Failed to resolve Hostname or IP",
								  addnode_dialog);
				}
				else{
					mUpdatePeersMethod();
				}
			}
			catch(Exception error){
				ClMsgDias.Err("Wrong Types in Values for Node add",
							  addnode_dialog);
			}
			addnode_dialog.Hide();
		}
	}
}
