using System;

using Gtk;
using Glade;

using P2Pc.net;

namespace P2Pc.gui {

	public class ClChangeTopicDialog
	{
		[Glade.Widget] Gtk.Dialog changetopic_dialog;
		[Glade.Widget] Entry topicentry;
		[Glade.Widget] Combo acccombo;
		[Glade.Widget] Label channamelabel;
		string mstrTopic;
		IChannel moChannel;
		IPL moPL;

		public ClChangeTopicDialog(Gtk.Window oParentWindow,
								   IPL oPL,
								   IChannel oChannel,
								   string strTopic)
		{
			moPL = oPL;
			moChannel = oChannel;
			mstrTopic = strTopic;
			Glade.XML gxmlChangetopicDia = new Glade.XML(null, "p2pc.glade", "changetopic_dialog", null);
			if(gxmlChangetopicDia!=null){
				gxmlChangetopicDia.Autoconnect(this);
				changetopic_dialog.TransientFor = oParentWindow;
				try{
					if(strTopic!=null) topicentry.Text = strTopic;
					if(oChannel!=null) channamelabel.Text = oChannel.PName;
				}
				catch(Exception){
					changetopic_cancel(null, null);
				}
			}
		}

		protected void changetopic_cancel(object sender, EventArgs e)
		{
			changetopic_dialog.Hide();
		}

		protected void changetopic_ok(object sender, EventArgs e){
			string strNewTopic = topicentry.Text;
			moPL.change_topic(moChannel, strNewTopic);
			changetopic_dialog.Hide();
		}
	}
}
