using System;
using System.Threading;

using Gtk;
using Glade;

using P2Pc.net;
using P2Pc.util;

namespace P2Pc.gui {

	public class ClLogDialog
	{
		[Glade.Widget] Gtk.Dialog log_dialog;
		[Glade.Widget] SpinButton spinbutton1;
		[Glade.Widget] TextView logtextview;
		[Glade.Widget] ScrolledWindow swtextview;

		public ClLogDialog(Gtk.Window oParentWindow)
		{
			Glade.XML gxmlLogDia = new Glade.XML(null, "p2pc.glade", "log_dialog", null);
			if(gxmlLogDia!=null){
				gxmlLogDia.Autoconnect(this);
				log_dialog.TransientFor = oParentWindow;
				Logger.PLogger = new DLogger(logHandler);
				logtextview.Editable = false;
				logtextview.CursorVisible = false;
				//logtextview.FocusVadjustment = swtextview.Vadjustment;
			}
		}

		public void logHandler(string strMsg){
			if(P2Pc_GUI.mbGdkLockThread){
				throw new SynchronizationLockException("Gdk: Already entered!");
			}
			if(Thread.CurrentThread.Name!=P2Pc_GUI.mstrMainThreadName)
			{
				P2Pc_GUI.mbGdkLockThread=true;
				Gdk.Threads.Enter();
			}

			logtextview.Buffer.Text += strMsg;

			swtextview.Vadjustment.Value = swtextview.Vadjustment.Upper;
			logtextview.ScrollToIter(logtextview.Buffer.EndIter,0.0,true,0,0);
			swtextview.Vadjustment.Value = swtextview.Vadjustment.Upper;
			swtextview.ShowAll();

			if(P2Pc_GUI.mbGdkLockThread){
				Gdk.Threads.Leave();
				P2Pc_GUI.mbGdkLockThread = false;
			}
		}

		protected void update_loglevel(object sender, EventArgs e)
		{
			Logger.PLevel = (int)spinbutton1.Value;
		}

		protected void close_logdialog(object sender, EventArgs e)
		{
			log_dialog.Hide();
		}
	}
}
