using System;

using Gtk;
using Glade;

namespace P2Pc.gui {

	public class ClMsgDias
	{
		/*
		 * Message Dialog BASICS (Constructor Arguments)
		 *
		 *  Window:          The parent window the msgdia is centered on
		 *  DialogFlags:     Modal: Msgdia has focus, other wins don't work
		 *                   DestroyWithParent: Kill msgdia with parent window
		 *  MessageType:     The displayed sign, one of:
		 *                    Info, Warning, Question, Error
		 *  ButtonsType:     The kind of displayed buttons, one of:
		 *                    None, Ok, Close, Cancel, YesNo, OkCancel
		 *  string:          The message to display
		*/

		public static void Info(string strMsg, Window parent){
			MessageDialog md = new MessageDialog (parent, 
												  DialogFlags.Modal,
												  MessageType.Info,
												  ButtonsType.Ok,
												  strMsg);
			md.Run ();
			md.Destroy();
		}

		public static void Warn(string strMsg, Window parent){
			MessageDialog md = new MessageDialog (parent, 
												  DialogFlags.Modal,
												  MessageType.Warning,
												  ButtonsType.Ok,
												  strMsg);
			md.Run ();
			md.Destroy();
		}

		public static void Err(string strMsg, Window parent){
			MessageDialog md = new MessageDialog (parent, 
												  DialogFlags.Modal,
												  MessageType.Error,
												  ButtonsType.Ok,
												  strMsg);
			md.Run ();
			md.Destroy();
		}

		public static bool OkCancel(string strMsg, Window parent){
			MessageDialog md = new MessageDialog (parent, 
												  DialogFlags.Modal,
												  MessageType.Question,
												  ButtonsType.OkCancel,
												  strMsg);
			return (ResponseType.Ok == (ResponseType) md.Run() );
		}

		public static bool YesNo(string strMsg, Window parent){
			MessageDialog md = new MessageDialog (parent, 
												  DialogFlags.Modal,
												  MessageType.Question,
												  ButtonsType.YesNo,
												  strMsg);
			return (ResponseType.Yes == (ResponseType) md.Run() );
		}
	}
}
