/*
 * Created by SharpDevelop.
 * User: Vitus
 * Date: 22.06.2004
 * Time: 11:46
 *
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using System.IO;
using System.Text;
using System.Security;
using System.Security.Cryptography;
//using NUnit.Framework;


using P2Pc.net;
using P2Pc.util;

namespace P2Pc.io
{
	/// <summary>
	/// tests the XML classes
	/// </summary>
	//[TestFixture]
    public class CTestXML
	{
		
		private	UTF8Encoding FUtf8Enc = new UTF8Encoding();
 			
		private byte[] build(chatmessage cm)
		{
 			//set local nick name and certs
 			CConMan.PLocalNickName = "derDoc@gmx.de";
			CConMan.PLocalX509Cert = Load("derDoc@gmx.de-cert.der");
 			byte[] data = Load("derDoc@gmx.de-key.pem.der");
			
 			Mono.Security.ASN1 privateKey = new Mono.Security.ASN1 (data);
			RSA rsa = Mono.Security.Cryptography.PKCS8.PrivateKeyInfo.DecodeRSA(privateKey[2].Value);
			CConMan.PLocalRSA = rsa;
			
			byte[] ret=null;
			
			try{
				ret=CSerializer.build(cm,true);
			}
			catch (Exception e){Console.WriteLine("Error:"+e);}
			
			Console.WriteLine("Build XML String:\n"+FUtf8Enc.GetString(ret));
			Console.WriteLine("-------------------------");
			return ret;
			
		}
		
		private chatmessage read(byte[] ret){
			chatmessage[] cm = null;
			
			Console.WriteLine("read XML String:\n"+FUtf8Enc.GetString(ret));
			
			try{
				cm = CSerializer.parse(ret);
			}catch (Exception e){Console.WriteLine("Error:"+e);}
			//if (cm==null) Console.WriteLine("Error cm=null");
			//else{
				Console.WriteLine("Type:"+((JoinMessage)cm[0].Item).CMType.Name);
				Console.WriteLine("chan:"+((JoinMessage)cm[0].Item).channel);
				//Console.WriteLine("version:"+((HelloMessage)cm[0].Item).version);
				//Console.WriteLine("greet:"+((HelloMessage)cm[0].Item).greeting);
				Console.WriteLine("-------------------------");
				Console.WriteLine("ToString:"+cm[0].ToString());
			
			return cm[0];
			
			
		}
		private byte[] Load (string filename)
		{
			byte[] data = null;
			using (FileStream fs = File.OpenRead (filename)) {
				data = new byte [fs.Length];
				fs.Read (data, 0, data.Length);
			}
			return data;
		}
	
		private void Save (string filename,byte[] data)
		{
			using (FileStream fs = File.OpenWrite (filename)) {
				fs.Write (data, 0, data.Length);
			}
		}
		
		//[Test]
        public void Main ()
		{
			
			chatmessage cm = new chatmessage(typeof(JoinMessage),32,true);
			((JoinMessage)cm.Item).channel="ficken";
			Console.WriteLine("CM:"+cm.ToString());
			
			byte[] b = build(cm);
			chatmessage cm2 = read(b);
			//Assert.AreEqual(cm,cm2);

		}
	}
}
