/* CKnownMsgs - static class that knows seen MIDs..
 * puts it all into a Hastable for fast acces
 * deleteOld is periodically called to delete old MIDs
 *
 * Created by SharpDevelop.
 * User: Vitus
 * Date: 05.07.2004
 * Time: 15:44
 *
 */
 using System;
 using System.Collections;
 using P2Pc.util;

 namespace P2Pc.net{

 	public class CKnownMsgs {
 		#region Fields
 		private static Hashtable FTable;
 		#endregion

 		#region Constructors
 		static CKnownMsgs(){
 			FTable = Hashtable.Synchronized(new Hashtable(23));
 		}
 		#endregion

 		#region Methods
 		public static bool isKnown(string pMid){
 			if (pMid==null || pMid=="") return false;
 			else return FTable.Contains(pMid);
 		}

 		public static void AddMID(string pMid){
 			if (pMid!=null && pMid != ""){
 				try{
 					FTable.Add(pMid,DateTime.Now);
 				}catch (Exception){
 					Logger.Log("KnownMIDs",4,"Already added MID="+pMid);
 				}
 			}
 		}

 		public static void deleteOld(){
 			//iterate over all keys (coz iterating over table itself would cause a ConcurrentModificationException on Remove)
 			try{
				Hashtable ht = (Hashtable)FTable.Clone();
 				foreach (object mkey in ht.Keys){
 					//get the value (DateTime)
 					if ( ((TimeSpan) (DateTime.Now - (DateTime)ht[mkey]) ).Minutes > 0){
 						//is older than 1min->delete
 						FTable.Remove(mkey);
						Logger.Log("KnownMIDs",5,"removed MID...");
 					}
 				}
			}catch(Exception e){ Logger.Log("KnownMIDs",2,"Error removing known MID:",e); }

 		}

		public static int PCount
		{
			get{
				return FTable.Count;
			}
		}

 		#endregion


 	}

}
