/* ChannelEventArgs - class for the event from a channel
 * just so that the sink knows what type of event occured
 * 
 * User: Vitus
 *
 */

using System;
namespace P2Pc.net{

	public enum ChannelEventType{
		Message,UserWantsToJoin,UserJoined,UserLeft,TopicSet
	}
	
	public class ChannelEventArgs : EventArgs {
	
		public readonly ChannelEventType type;
		public readonly IUser affectedUser;
		public readonly string text;
		
		public ChannelEventArgs(ChannelEventType cet,IUser iu, string pText){
			type=cet;
			affectedUser = iu;
			text = pText;
		}
		
	}
}
