/* IChannel - Interface for the Channel class
 * 
 * Created by SharpDevelop.
 * User: Vitus
 *
 */

using System;
using System.Security.Cryptography;

namespace P2Pc.net{
	
	public delegate void DChannelEventHandler(object sender,
	                                          ChannelEventArgs e);
	
	
	public interface IChannel : IAbstractNetInfo{
		#region Methods
		void		sendMessage(string msg);
		void		acceptUser(IUser user);
		void		join();
		void		leave();
		#endregion
		
		#region Properties
		bool PbLocalUserMember
		{
			get;
			set;
		}
		
		bool PbClosed
		{
			get;
		}
		string PName
		{
			get;
		}
		
		string PTopic
		{
			get;
			set;
		}
		
		byte[] PSymKey
		{
			get;
			set;
		}
		
		SymmetricAlgorithm PSymAlgo
		{
			get;
		}
		
		IUser[] PUsers
		{
			get;
		}
		
		DateTime PLastChannelMessage
		{
			get;
		}
		#endregion
		
		#region Events
		event DChannelEventHandler EvChannelEvent;
		#endregion
		
	}
}
