/* static class Logger - Is the main Logging facility for P2Pc
 * logs in a format similar to xfer_log to the stream set
 * can log only a String, a String with a CM and also a Exception
 * 
 * Created by SharpDevelop.
 * User: Vitus
 * Date: 28.06.2004
 * Time: 16:26
 *
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
 
 using System;
 using System.IO;
 using P2Pc.io;
 //defining the logging
 
 namespace P2Pc.util{

	public delegate void DLogger(string message);

 	public class Logger{
 		
 		private static TextWriter FStream = TextWriter.Synchronized(Console.Out);
		private static DLogger logmethod = null;
 		private static int FLevel = 1;
 		private enum ELevels{
 			INFO=0,ERROR,WARNING,DEBUG,VERBOSE,INSANE
 		}
 		
 		public static TextWriter PStream{
 			set{
 				if (value!=null) FStream = TextWriter.Synchronized(value);
 				Log("Logger",0,"Logging initialized for this stream");
 			}
 		}

		public static DLogger PLogger{
			set{
				Console.WriteLine("logger registered.");
				logmethod = value;
 				Log("Logger",0,"Logger registered");
			}
		}
 		
 		public static int PLevel{
 			get{
 				return FLevel;
 			}
 			set{
 				if (value>0 && value<6){
 					FLevel = value;
 					Log("Logger",0,"LogLevel set to "+value+" ("
 					                  +Enum.Format(typeof(ELevels),value,"G")+")");
 				}
 			}
 		}
 		
 		public static void Log(string pSource, int pLevel, string pStr2Log, chatmessage pcm, Exception e){
 			if (pLevel <= FLevel){
 				FStream.WriteLine(log_start(pLevel)+" ["+pSource+"] " + pStr2Log
 				    +( (pcm!=null)? (" \""+pcm.ToString()+"\"") : "") 
 				    + ( (FLevel > 3&&e!=null)? (":\""+e.ToString()+"\"") : "")
 				);
 				FStream.Flush();
				if(logmethod!=null){
					logmethod(log_start(pLevel)+" ["+pSource+"] " + pStr2Log
						+( (pcm!=null)? (" \""+pcm.ToString()+"\"") : "") 
						+ ( (FLevel > 3&&e!=null)? (":\""+e.ToString()+"\"") : "") +"\n");
				}
 			}
 		}
 		public static void Log(string pSource, int pLevel, string pStr2Log){
 			Log(pSource,pLevel,pStr2Log,null,null);
 		}
 		public static void Log(string pSource, int pLevel, string pStr2Log,chatmessage cm){
 			Log(pSource,pLevel,pStr2Log,cm,null);
 		}
 		public static void Log(string pSource, int pLevel, string pStr2Log,Exception e){
 			Log(pSource,pLevel,pStr2Log,null,e);
 		}
 		
 		private static string log_start(int lev){
 			return DateTime.Now.ToString("G",null) + " " + Enum.Format(typeof(ELevels),lev,"G");
 		}
 		
 	}
 	
 	
}
